<template>
  <div class="sidebar-content">
    <v-toolbar>
      <v-text-field
        v-model="searchField"
        label="Search"
        single-line
        hide-details
        clearable
        :loading="isSearching"
        append-icon="mdi-magnify"
      />
    </v-toolbar>
    <v-list
      class="chat-rooms"
      v-show="isSearchFieldEmpty"
    >
      <v-list-item
        v-for="conv in conversations"
        :key="conv.id"
        class="conversation-item"
        :class="{selected: conv == selectedChatRoom}"
        @click="onConversationItemClick(conv)"
        :title="conv.name"
      >
        <conversation-list-item-content
          :title="conv.name"
          :last-message="conv.lastMessage"
          :unread-messages="conv.newMessages"
        />
      </v-list-item>

      <v-overlay
        :value="isLoadingConversations"
        absolute
      >
        <v-progress-circular
          indeterminate
          size="64"
        />
      </v-overlay>
    </v-list>
    <v-btn
      v-if="isSearchFieldEmpty"
      class="new-group-btn m-2"
      fab
      dark
      color="primary"
      title="Create a new group"
      @click.stop="createNewGroupDialog = true"
    >
      <v-icon dark>
        mdi-message-text
      </v-icon>
    </v-btn>
    
    <v-list
      class="search-results"
      v-if="!isSearchFieldEmpty"
    >
      <v-list-item
        v-for="(searchItem, idx) in searchResults"
        :key="idx"
        link
        class="search-results-item"
        :class="{ person: searchItem.isUser, group: !searchItem.isUser }"
        @click="onSearchResultItemClick(searchItem)"
        :title="searchItem.name"
      >
        <v-list-item-content>
          <v-list-item-title>{{ searchItem.name }}</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
    </v-list>

    <!-- create group dialog -->
    <v-dialog
      v-model="createNewGroupDialog"
      width="300"
    >
      <v-card>
        <v-card-title class="text-h6">
          Enter a group name
        </v-card-title>
        <v-card-text>
          <v-form
            ref="groupNameInput"
            v-model="isGroupNameValid"
            @submit.prevent="createGroup"
          >
            <v-text-field
              v-model="groupName"
              :rules="[groupNameRules.required, groupNameRules.invalidSymbol]"
              :error-messages="groupNameValidationErrors"
              label="Group name"
              maxlength="100"
            />
          </v-form>
        </v-card-text>

        <v-card-actions>
          <v-spacer />

          <v-btn
            color="secondary"
            text
            @click="createNewGroupDialog = false"
          >
            Cancel
          </v-btn>

          <v-btn
            color="success"
            text
            @click="createGroup"
          >
            Create
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import {
  findUsersAndConversations,
  createGroup
} from "../services/chatApi";
import * as SignalRService from "../services/signalrService.js";
import ConversationListItemContent from './ConversationListItemContent.vue';

export default {
  components: { ConversationListItemContent },
  data() {
    return {
      searchField: "",
      isSearching: false,
      timeoutBeforeSearch: null,
      searchResults: null,
      createNewGroupDialog: false,
      groupName: "",
      groupNameRules: {
          required: value => !!value || 'Required',
          invalidSymbol: value => !value.startsWith("@") || "Can not start with @"
      },
      isGroupNameValid: false,
      groupNameValidationErrors: []
    };
  },
  props: {
    selectedChatRoom: {
      type: Object,
      default: null
    }
  },
  computed: {
    conversations() {
      return this.$store.getters.conversations;
    },
    isSearchFieldEmpty() {
      return !this.searchField || this.searchField.length === 0;
    },
    isLoadingConversations() {
      return this.$store.getters.isLoadingConversations;
    }
  },
  watch: {
    searchField: function (oldValue, newValue) {
      this.initiateSearch();
    },
    createNewGroupDialog: function (oldValue, newValue) {
      if (!newValue) {
        this.isGroupNameValid = null;
        this.groupName = "";
      }
    }
  },
  methods: {
    initiateSearch() {
      if (this.searchField === null || this.searchField?.length < 2) {
        this.isSearching = false;
        return;
      }

      if (this.timeoutBeforeSearch != null)
        clearTimeout(this.timeoutBeforeSearch);
      this.timeoutBeforeSearch = setTimeout(() => this.findChatRooms(), 750);
      this.isSearching = true;
    },
    async findChatRooms() {
      if (this.searchField === null || this.searchField?.length < 2) {
        this.isSearching = false;
        return;
      }

      let response = await findUsersAndConversations(this.searchField);
      if (response.requestSuccess) {
        this.searchResults = response.payload;
      } else {
        this.searchResults = null;
        console.log(response.error);
      }
      this.isSearching = false;
    },
    async getUserConversations() {
      await this.$store.dispatch("loadConversations");
    },
    onConversationItemClick(item) {
      this.$emit("select-conversation", item);
    },
    onSearchResultItemClick(item) {
      if (item.isUser) this.$emit("select-user", item);
      else this.$emit("select-conversation", item);
      this.searchField = null;
    },
    validateGroupName() {
      this.$refs.groupNameInput.validate();
    },
    async createGroup() {
      this.validateGroupName();
      if (!this.isGroupNameValid) return;

      let result = await createGroup(this.groupName);
      if (result.requestSuccess) {
        SignalRService.joinGroup(result.payload.id);
        this.getUserConversations();
        this.createNewGroupDialog = false;
        this.groupName = "";
      }
      else {
        if (result.error == "duplicate") {
          this.groupNameValidationErrors = "A group with this name already exists";
        }
        else {
          console.log(result.error);
        }
      }
    }
  },
  mounted() {
    this.getUserConversations();
  },
};
</script>

<style>
.search-results-item.group .v-list-item__title {
  text-decoration: underline;
}

.conversation-item.selected.theme--light {
  background-color: rgba(0, 0, 0, 0.15)
}

.sidebar-content {
  display: flex;
  flex-direction: column;
  max-height: 100%;
  min-height: 100%;
  height: 1px; /* absolute value is required to make available relative sizing in child nodes */
}

.sidebar-content > header {
  flex-grow: 0;
}

.chat-rooms {
  overflow-y: auto;
  position: relative;
  flex-grow: 1;
}

.new-group-btn {
  position: absolute;
  right: 20px;
  bottom: 5px;
}
</style>